from graphviz import Digraph
graphe = Digraph(strict=True)

class Pile :
    def __init__(self) :
        self.l = []

    def __str__(self) :
        s = "pile : "
        for e in self.l : s += str(e) + " "
        return s

    def empiler(self,e) :
        self.l.append(e)

    def depiler(self) :
        return self.l.pop()

    def estVide(self) :
        return self.l == []

class File :
    def __init__(self) :
        self.l = []

    def __str__(self) :
        s = "pile : "
        for e in self.l : s += str(e) + " "
        return s

    def enfiler(self,e) :
        self.l.append(e)

    def defiler(self) :
        return self.l.pop(0)

    def estVide(self) :
        return self.l == []

class Graph :
    def trace_graphique(self) :
        graphe.clear()
        l = [self]
        n = 0
        while l != [] :
            n += 1
            nd = l.pop(0)
            nd.num = str(n)
            graphe.node(nd.num , str(nd.info))
            if nd.fg != None :
                l.append(nd.fg)
            if nd.fd != None :
                l.append(nd.fd)
        l = [self]
        while l != [] :
            nd = l.pop(0)
            if nd.fg != None :
                graphe.edge(nd.num,nd.fg.num)
                l.append(nd.fg)
            if nd.fd != None :
                graphe.edge(nd.num,nd.fd.num)
                l.append(nd.fd)
        graphe.view()


